----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    22:38:51 04/08/2007 
-- Design Name: 
-- Module Name:    GF16_Mul_Inv - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity GF16_Mul_Inv is
    Port ( GF16_In : in  STD_LOGIC_VECTOR (3 downto 0);
           GF16_Mul_Inv_Out : out  STD_LOGIC_VECTOR (3 downto 0));
end GF16_Mul_Inv;

architecture Behavioral of GF16_Mul_Inv is
-- Internal signals.
signal a, a_inv : STD_LOGIC_VECTOR (3 downto 0);
			
begin
-- Internal routings.
a <= GF16_In;
GF16_Mul_Inv_Out <= a_inv;

-- Compute Multiplicative Inversion in GF(16).
a_inv(3) <= a(3) xor
				(a(3) and a(2) and a(1)) xor 
				(a(3) and a(0)) xor 
				a(2);
				
a_inv(2) <= (a(3) and a(2) and a(1)) xor 
				(a(3) and a(2) and a(0)) xor 
				(a(3) and a(0)) xor 
				a(2) xor 
				(a(2) and a(1));

a_inv(1) <= a(3) xor
				(a(3) and a(2) and a(1)) xor
				(a(3) and a(1) and a(0)) xor
				a(2) xor
				(a(2) and a(0)) xor
				a(1);

a_inv(0) <= (a(3) and a(2) and a(1)) xor
				(a(3) and a(2) and a(0)) xor
				(a(3) and a(1)) xor
				(a(3) and a(1) and a(0)) xor
				(a(3) and a(0)) xor
				a(2) xor
				(a(2) and a(1)) xor
				(a(2) and a(1) and a(0)) xor
				a(1) xor
				a(0);

end Behavioral;

