----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    22:47:23 04/06/2007 
-- Design Name: 
-- Module Name:    GF4_Mul - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity GF4_Mul is
    Port ( GF4_In_1 : in  STD_LOGIC_VECTOR (1 downto 0);
           GF4_In_2 : in  STD_LOGIC_VECTOR (1 downto 0);
           GF4_Out : out  STD_LOGIC_VECTOR (1 downto 0));
end GF4_Mul;

architecture Behavioral of GF4_Mul is
-- Internal signals.
signal A, B: STD_LOGIC_VECTOR (1 downto 0);
begin
-- Internal routings.
A <= GF4_In_1;
B <= GF4_In_2;

-- Compute GF(2^2) Multiplication.
process (A,B)
variable GF2_Mul_Res1, GF2_Mul_Res2, GF2_Mul_Res3: STD_LOGIC;
begin
GF2_Mul_Res1 := A(1) and B(1);
GF2_Mul_Res2 := (A(1) xor A(0)) and (B(1) xor B(0));
GF2_Mul_Res3 := A(0) and B(0);
GF4_Out(1) <= GF2_Mul_Res2 xor GF2_Mul_Res3;
GF4_Out(0) <= GF2_Mul_Res1 xor GF2_Mul_Res3;
end process;

end Behavioral;

