----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    22:56:53 04/13/2007 
-- Design Name: 
-- Module Name:    Inv_Iso_Map_AT - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity Inv_Iso_Map_AT is
    Port ( GFComp : in  STD_LOGIC_VECTOR (7 downto 0);
           GF256 : out  STD_LOGIC_VECTOR (7 downto 0));
end Inv_Iso_Map_AT;

architecture Behavioral of Inv_Iso_Map_AT is
-- Internal signals.
signal B: STD_LOGIC_VECTOR (7 downto 0);
begin
-- Internal routings.
B <= GFComp;

-- Mapping Composite Fields back to GF(256) and Affine Transformation.
process (B)
begin
   GF256(7) <= B(7) xor B(3) xor B(2);
   GF256(6) <= B(7) xor B(6) xor B(5) xor B(4) xor '1';
   GF256(5) <= B(7) xor B(2) xor '1';
   GF256(4) <= B(7) xor B(4) xor B(1) xor B(0);
	GF256(3) <= B(2) xor B(1) xor B(0);
	GF256(2) <= B(6) xor B(5) xor B(4) xor B(3) xor B(2) xor B(0);
	GF256(1) <= B(7) xor B(0) xor '1';
	GF256(0) <= B(7) xor B(6) xor B(2) xor B(1) xor B(0) xor '1';
end process;
			
end Behavioral;

