----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    23:21:15 04/05/2007 
-- Design Name: 
-- Module Name:    Map_Iso - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity Map_Iso is
    Port ( GF256 : in  STD_LOGIC_VECTOR (7 downto 0);
           GFComp : out  STD_LOGIC_VECTOR (7 downto 0));
end Map_Iso;

architecture Behavioral of Map_Iso is
-- Internal signals.
signal B: STD_LOGIC_VECTOR (7 downto 0);
begin
-- Internal routings.
B <= GF256;

-- Mapping GF(256) to Composite Fields.
process (B)
begin
   GFComp(7) <= B(7) xor B(5);
	GFComp(6) <= B(7) xor B(6) xor B(4) xor B(3) xor B(2) xor B(1);
	GFComp(5) <= B(7) xor B(5) xor B(3) xor B(2);
	GFComp(4) <= B(7) xor B(5) xor B(3) xor B(2) xor B(1);
	GFComp(3) <= B(7) xor B(6) xor B(2) xor B(1);
	GFComp(2) <= B(7) xor B(4) xor B(3) xor B(2) xor B(1);
	GFComp(1) <= B(6) xor B(4) xor B(1);
	GFComp(0) <= B(6) xor B(1) xor B(0);
end process;
			
end Behavioral;

